using ValidatorsLibrary;

namespace ValidatorTests;

public class RangeValidatorTestsInt
{
    [Fact]
    public void Valid_Middle()
    {
        var validator = new RangeValidator<int>{ Min = 5, Max = 10 };
        Assert.Empty(validator.Validate(7));
    }
    
    [Fact]
    public void Valid_Min()
    {
        var validator = new RangeValidator<int>{ Min = 5, Max = 10 };
        Assert.Empty(validator.Validate(5));
    }
    
    [Fact]
    public void Valid_Max()
    {
        var validator = new RangeValidator<int>{ Min = 5, Max = 10 };
        Assert.Empty(validator.Validate(10));
    }
    
    [Fact]
    public void Invalid_Under()
    {
        var validator = new RangeValidator<int> { Min = 5, Max = 10 };
        Assert.NotEmpty(validator.Validate(-5));
    }

    [Fact]
    public void Invalid_Over()
    {
        var validator = new RangeValidator<int> { Min = 5, Max = 10 };
        Assert.NotEmpty(validator.Validate(15));
    }
}

public class RangeValidatorTestsDouble
{
    [Fact]
    public void Valid_Middle()
    {
        var validator = new RangeValidator<double>{ Min = 5.0, Max = 10.0 };
        Assert.Empty(validator.Validate(7.0));
    }
    
    [Fact]
    public void Valid_Min()
    {
        var validator = new RangeValidator<double> { Min = 5.0, Max = 10.0 };
        Assert.Empty(validator.Validate(5.0));
    }
    
    [Fact]
    public void Valid_Max()
    {
        var validator = new RangeValidator<double> { Min = 5.0, Max = 10.0 };
        Assert.Empty(validator.Validate(10.0));
    }
    
    [Fact]
    public void Invalid_Under()
    {
        var validator = new RangeValidator<double> { Min = 5.0, Max = 10.0 };
        Assert.NotEmpty(validator.Validate(-5.0));
    }

    [Fact]
    public void Invalid_Over()
    {
        var validator = new RangeValidator<double> { Min = 5.0, Max = 10.0 };
        Assert.NotEmpty(validator.Validate(15.0));
    }
}
