﻿using ValidatorsLibrary;

namespace ValidatorTests;

public class StringLengthValidatorTests
{
    [Fact]
    public void Valid_InRange()
    {
        var validator = new StringLengthValidator(new RangeValidator<int> { Min = 5, Max = 10 });
        Assert.Empty(validator.Validate("12345678"));
    }

    [Fact]
    public void Invalid_UnderRange()
    {
        var validator = new StringLengthValidator(new RangeValidator<int> { Min = 5, Max = 10 });
        Assert.NotEmpty(validator.Validate("123"));
    }

    [Fact]
    public void Invalid_OverRange()
    {
        var validator = new StringLengthValidator(new RangeValidator<int> { Min = 5, Max = 10 });
        Assert.NotEmpty(validator.Validate("123456789123456789"));
    }
}