﻿namespace ValidatorsLibrary;

public class StringLengthValidator(IValidator<int> lengthValidator) : IValidator<string>
{
    public IValidator<int> LengthValidator { get; init; } = lengthValidator;

    public IEnumerable<ValidationError> Validate(string value)
    {
        var lengthErrors = LengthValidator.Validate(value.Length);

        List<ValidationError>? errors = null;
        foreach (var lengthError in lengthErrors)
        {
            errors ??= new List<ValidationError>();
            errors.Add(new ValidationError($"\"{value}\" length {lengthError.Reason}"));
        }

        if (errors is null)
            return Array.Empty<ValidationError>();

        return errors;
    }
}
