﻿namespace ValidatorsLibrary;

public class ValidationError(string reason)
{
    public string Reason { get; init; } = reason;
}

public static class EnumerableValidationErrorExtensions
{
    public static void Print(this IEnumerable<ValidationError> errors)
    {
        if (errors.Any())
        {
            Console.WriteLine("  >>> Validation failed >>>");
            foreach (var error in errors)
            {
                Console.WriteLine("    > " + error.Reason);
            }
        }
        else
        {
            Console.WriteLine("  >>> Validation successful >>>");
        }
        Console.WriteLine();
    }
}
